"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkN5KTMDVOcjs = require('./chunk-N5KTMDVO.cjs');

// src/common/exec/throttle-debounce.ts
function throttle(callback, opt = {}) {
  const { delay = 100, trailing = true, leading = true } = opt;
  let timeoutID;
  let checkpoint = 0;
  let visited = 0;
  let trailingExec;
  function clearExistingTimeout() {
    if (timeoutID) {
      clearTimeout(timeoutID);
      timeoutID = void 0;
      return true;
    }
    return false;
  }
  function wrapper(...args) {
    const now = Date.now();
    const elapsed = now - checkpoint;
    const exec = () => {
      visited = 0;
      checkpoint = Date.now();
      callback.apply(this, args);
    };
    trailingExec = exec;
    if (elapsed > delay || !timeoutID) {
      if (leading) {
        if (elapsed > delay) {
          exec();
        } else {
          ++visited;
        }
      }
      const timeout = elapsed > delay ? delay : delay - elapsed;
      clearExistingTimeout();
      checkpoint = now;
      timeoutID = setTimeout(() => {
        clearExistingTimeout();
        if (trailing && (!leading || visited > 0)) {
          _optionalChain([trailingExec, 'optionalCall', _ => _()]);
        }
      }, timeout);
    } else {
      ++visited;
    }
  }
  wrapper.cancel = clearExistingTimeout;
  wrapper.stop = () => {
    if (clearExistingTimeout() && trailingExec)
      trailingExec();
  };
  wrapper.immediate = async function immediate(...args) {
    clearExistingTimeout();
    checkpoint = Date.now();
    callback.apply(this, args);
  };
  wrapper.dispose = () => wrapper.stop();
  return wrapper;
}
function debounce(callback, opt = {}) {
  const { delay = 100 } = opt;
  let timeoutID;
  let running = false;
  let lastArguments;
  function clearExistingTimeout() {
    if (timeoutID) {
      clearTimeout(timeoutID);
      timeoutID = void 0;
    }
  }
  async function exec() {
    try {
      clearExistingTimeout();
      if (lastArguments != null) {
        const args = [...lastArguments];
        lastArguments = void 0;
        running = true;
        await _chunkN5KTMDVOcjs.promisify.call(void 0, callback(...args));
        running = false;
        if (lastArguments != null) {
          clearExistingTimeout();
          timeoutID = setTimeout(exec, delay);
        }
      }
    } catch (err) {
    }
  }
  function wrapper(...args) {
    lastArguments = [...args];
    clearExistingTimeout();
    if (running === false)
      timeoutID = setTimeout(exec, delay);
  }
  async function immediate(...args) {
    clearExistingTimeout();
    lastArguments = [...args];
    await exec();
  }
  wrapper.cancel = clearExistingTimeout;
  wrapper.dispose = clearExistingTimeout;
  wrapper.immediate = immediate;
  return wrapper;
}




exports.throttle = throttle; exports.debounce = debounce;
//# sourceMappingURL=chunk-5G52PYZN.cjs.map