// src/common/timeout.ts
function safeTimeout(fn, delay = 0, unref = false) {
  let timerId;
  const disposeTimer = () => {
    clearTimeout(timerId);
    timerId = void 0;
  };
  timerId = setTimeout(() => {
    fn();
    disposeTimer();
  }, delay);
  if (unref)
    timerId.unref?.();
  return disposeTimer;
}

export {
  safeTimeout
};
//# sourceMappingURL=chunk-7QYVSWCZ.js.map