"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkTUWUD5A6cjs = require('./chunk-TUWUD5A6.cjs');


var _chunkW3WUDQICcjs = require('./chunk-W3WUDQIC.cjs');


var _chunkYY4AHBBLcjs = require('./chunk-YY4AHBBL.cjs');

// src/node/filestorage.ts
var _fs = require('fs');
var _path = require('path');
var _buffer = require('buffer');
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
var FileStorage = class {
  constructor(opt = {}) {
    this.store = {};
    this.fileKeys = void 0;
    this.pretty = false;
    this.dirname = _path.resolve.call(void 0, _process2.default.cwd(), _nullishCoalesce(opt.path, () => ( ".fileStorage")));
    this.pretty = !!opt.pretty;
    this.extension = _nullishCoalesce(opt.extension, () => ( ".json"));
    if (opt.extension && !this.extension.startsWith("."))
      this.extension = `.${this.extension}`;
    this.extensionLength = this.extension.length;
    this.objectToString = _nullishCoalesce(opt.objectToString, () => ( ((data) => {
      return this.pretty ? _chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, data, null, 2) : _chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, data);
    })));
    this.objectFromString = _nullishCoalesce(opt.objectFromString, () => ( ((data) => {
      try {
        return JSON.parse(data);
      } catch (err) {
      }
    })));
    this.keyToFilename = _nullishCoalesce(opt.keyToFilename, () => ( _chunkTUWUD5A6cjs.toValidFilename));
  }
  setItem(key, value) {
    this.store[key] = _chunkW3WUDQICcjs.cloneObject.call(void 0, value);
    try {
      const data = this.objectToString(value);
      const path = this.getPath(key);
      _fs.mkdirSync.call(void 0, _path.dirname.call(void 0, path), { recursive: true });
      _fs.writeFileSync.call(void 0, path, data, "utf8");
    } catch (err) {
    }
  }
  getPath(key) {
    return _path.resolve.call(void 0, this.dirname, this.keyToFilename(key) + this.extension);
  }
  getBuffer(key) {
    const path = this.getPath(key);
    return _buffer.Buffer.from(_fs.readFileSync.call(void 0, path));
  }
  getItem(key) {
    const value = this.store[key];
    if (value === null)
      return;
    if (value != null)
      return _chunkW3WUDQICcjs.cloneObject.call(void 0, value);
    try {
      const path = this.getPath(key);
      const data = _fs.readFileSync.call(void 0, path, "utf8");
      if (data != null) {
        const value2 = this.objectFromString(data);
        this.store[key] = value2;
        return value2;
      }
    } catch (err) {
      this.store[key] = null;
    }
  }
  removeItem(key) {
    delete this.store[key];
    if (this.fileKeys != null) {
      const index = this.fileKeys.indexOf(key);
      if (index !== -1)
        this.fileKeys.splice(index, 1);
    }
    try {
      const path = this.getPath(key);
      _fs.unlinkSync.call(void 0, path);
    } catch (err) {
    }
  }
  clear() {
    this.fileKeys = [];
    this.store = {};
    _fs.rmSync.call(void 0, this.dirname, { recursive: true, force: true });
  }
  allKeys() {
    if (this.fileKeys == null) {
      try {
        this.fileKeys = _fs.readdirSync.call(void 0, this.dirname, { withFileTypes: true }).filter(
          (item) => !item.isDirectory() && item.name.endsWith(this.extension)
        ).map((item) => item.name.slice(0, -this.extensionLength)) || [];
      } catch (err) {
      }
    }
    const keys = [...this.fileKeys || []];
    for (const key of Object.keys(this.store)) {
      if (!keys.includes(key))
        keys.push(key);
    }
    keys.sort();
    return keys;
  }
};



exports.FileStorage = FileStorage;
//# sourceMappingURL=chunk-AIXBIBU7.cjs.map