"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkNQWFR5HDcjs = require('./chunk-NQWFR5HD.cjs');


var _chunkQT3OZZO4cjs = require('./chunk-QT3OZZO4.cjs');


var _chunkRLHQ6YHCcjs = require('./chunk-RLHQ6YHC.cjs');


var _chunkDRU33ZUGcjs = require('./chunk-DRU33ZUG.cjs');



var _chunkBXM45HLQcjs = require('./chunk-BXM45HLQ.cjs');

// src/common/schema/args.ts
function parseSchemaArgs(schema, args = _nullishCoalesce(_optionalChain([process, 'optionalAccess', _ => _.argv]), () => ( {}))) {
  _chunkQT3OZZO4cjs.assert.call(void 0, _chunkNQWFR5HDcjs.isSchemaObjectFlat.call(void 0, schema), "schema should be a flat object");
  const alias = {};
  const booleanArgs = [];
  _chunkRLHQ6YHCcjs.objectMap.call(void 0, schema._object, (key, schema2) => {
    if (_optionalChain([schema2, 'access', _2 => _2._props, 'optionalAccess', _3 => _3.argShort]))
      alias[_chunkBXM45HLQcjs.toCamelCase.call(void 0, schema2._props.argShort)] = _chunkBXM45HLQcjs.toCamelCase.call(void 0, key);
    if (schema2.type === "boolean") {
      booleanArgs.push(_chunkBXM45HLQcjs.toCamelCase.call(void 0, key));
    }
  });
  const argList = [...args];
  let arg;
  const names = [];
  const argsObj = {};
  while (arg = argList.shift()) {
    let value;
    if (/^--?/.test(arg)) {
      let key = arg.replace(/^--?/, "");
      if (arg.includes("=")) {
        const [name, valuePart] = key.split("=", 2);
        key = name.trim();
        value = valuePart.trim();
      }
      key = _chunkBXM45HLQcjs.toCamelCase.call(void 0, key);
      key = _nullishCoalesce(alias[key], () => ( key));
      if (booleanArgs.includes(key)) {
        argsObj[key] = true;
      } else {
        value = _nullishCoalesce(_nullishCoalesce(value, () => ( argList.shift())), () => ( ""));
        argsObj[key] = value;
      }
    } else {
      names.push(arg);
    }
  }
  const argsResult = _chunkRLHQ6YHCcjs.objectMap.call(void 0, schema._object, (key, schema2) => {
    let value = argsObj[_chunkBXM45HLQcjs.toCamelCase.call(void 0, key)];
    if (schema2.type === "number") {
      value = _chunkDRU33ZUGcjs.valueToInteger.call(void 0, value);
    }
    return schema2.parse(value);
  });
  return [argsResult, names];
}
function helpSchemaArgs(schema) {
  _chunkQT3OZZO4cjs.assert.call(void 0, _chunkNQWFR5HDcjs.isSchemaObjectFlat.call(void 0, schema), "schema should be a flat object");
  const lines = [];
  _chunkRLHQ6YHCcjs.objectMap.call(void 0, schema._object, (key, schema2) => {
    let s = `--${_chunkBXM45HLQcjs.fromCamelCase.call(void 0, key)}`;
    if (_optionalChain([schema2, 'access', _4 => _4._props, 'optionalAccess', _5 => _5.argShort]))
      s += `, -${_chunkBXM45HLQcjs.fromCamelCase.call(void 0, schema2._props.argShort)}`;
    if (schema2.type !== "boolean")
      s += `=${schema2.type}`;
    lines.push(s);
    if (_optionalChain([schema2, 'access', _6 => _6._props, 'optionalAccess', _7 => _7.argDesc]))
      lines.push(`  ${_optionalChain([schema2, 'access', _8 => _8._props, 'optionalAccess', _9 => _9.argDesc])}`);
  });
  return lines.join("\n");
}




exports.parseSchemaArgs = parseSchemaArgs; exports.helpSchemaArgs = helpSchemaArgs;
//# sourceMappingURL=chunk-CECDKOWH.cjs.map