"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }





var _chunkVAG3XY63cjs = require('./chunk-VAG3XY63.cjs');

// src/common/data/object.ts
function objectMap(obj, fn) {
  if (!_chunkVAG3XY63cjs.isObject.call(void 0, obj))
    return {};
  return Object.fromEntries(
    Object.entries(obj).map(([k, v]) => {
      const r = fn(k, v);
      if (_chunkVAG3XY63cjs.isArray.call(void 0, r) && r.length === 2)
        return r;
      return [k, r];
    }).filter((v) => v != null)
  );
}
function objectFilter(obj, fn) {
  if (!_chunkVAG3XY63cjs.isObject.call(void 0, obj))
    return {};
  return Object.fromEntries(Object.entries(obj).filter(([k, v]) => fn(k, v)));
}
function objectMergeDisposable(a, b) {
  if (b.dispose && a.dispose) {
    b.dispose.add(a.dispose);
  }
  return Object.assign(a, b);
}
function objectIsEmpty(obj) {
  return Object.keys(obj).length <= 0;
}
function objectPick(obj, ...keys) {
  return Object.fromEntries(keys.filter((key) => key in obj).map((key) => [key, obj[key]]));
}
function objectInclusivePick(obj, ...keys) {
  return Object.fromEntries(keys.map((key) => [key, obj[key]]));
}
function objectOmit(obj, ...keys) {
  return Object.fromEntries(Object.entries(obj).filter(([key]) => !keys.includes(key)));
}
function objectPlain(obj, opt) {
  const {
    maxDepth = 99,
    circleValue,
    maxDepthValue,
    errorTrace = true,
    filter = () => true,
    keepAsIs = () => false,
    transformer = () => void 0
  } = _nullishCoalesce(opt, () => ( {}));
  const cycle = [];
  function handleObject(obj2, depth) {
    if (depth > maxDepth)
      return maxDepthValue;
    if (keepAsIs(obj2))
      return obj2;
    if (!_chunkVAG3XY63cjs.isPrimitive.call(void 0, obj2)) {
      if (cycle.includes(obj2))
        return circleValue;
      cycle.push(obj2);
    }
    if (transformer) {
      const result = transformer(obj2);
      if (result !== void 0)
        return result;
    }
    if (_chunkVAG3XY63cjs.isSymbol.call(void 0, obj2))
      return String(obj2);
    if (_chunkVAG3XY63cjs.isPrimitive.call(void 0, obj2))
      return obj2;
    if (obj2 instanceof Date) {
      return {
        __class: "Date",
        value: obj2.toISOString()
      };
    }
    if (obj2 instanceof RegExp) {
      return {
        __class: "RegExp",
        source: obj2.toString()
      };
    }
    if (obj2 instanceof Map)
      obj2 = Object.fromEntries(obj2);
    if (obj2 instanceof Set || _chunkVAG3XY63cjs.isBinaryArray.call(void 0, obj2))
      obj2 = Array.from(obj2);
    if (obj2 instanceof Error) {
      return {
        __class: "Error",
        name: obj2.name,
        message: obj2.message,
        stack: errorTrace ? obj2.stack : void 0,
        cause: obj2.cause ? String(obj2.cause) : void 0
      };
    }
    if (Array.isArray(obj2)) {
      return obj2.filter(filter).map((o) => handleObject(o, depth + 1));
    }
    const objName = _optionalChain([obj2, 'optionalAccess', _ => _.constructor, 'optionalAccess', _2 => _2.name]);
    if (objName && objName !== "Object") {
      const nobj2 = {
        __class: objName
        // __code: obj.toString ? obj.toString() : undefined,
      };
      for (const k in obj2) {
        if (Object.hasOwn(obj2, k) && _chunkVAG3XY63cjs.isPrimitive.call(void 0, obj2[k]))
          nobj2[k] = obj2[k];
      }
      return nobj2;
    }
    const nobj = {};
    for (const key in obj2) {
      const value = obj2[key];
      if (filter(value))
        nobj[key] = handleObject(value, depth + 1);
    }
    return nobj;
  }
  return handleObject(obj, 0);
}










exports.objectMap = objectMap; exports.objectFilter = objectFilter; exports.objectMergeDisposable = objectMergeDisposable; exports.objectIsEmpty = objectIsEmpty; exports.objectPick = objectPick; exports.objectInclusivePick = objectInclusivePick; exports.objectOmit = objectOmit; exports.objectPlain = objectPlain;
//# sourceMappingURL=chunk-RLHQ6YHC.cjs.map