"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkB4JXPT6Icjs = require('./chunk-B4JXPT6I.cjs');

// src/common/data/string-hash-pool.ts
function useStringHashPool() {
  const hashToString = /* @__PURE__ */ new Map();
  const stringToHash = /* @__PURE__ */ new Map();
  function hash(s) {
    let v = stringToHash.get(s);
    if (v == null) {
      v = _chunkB4JXPT6Icjs.stringHashFNV1a.call(void 0, s);
      if (hashToString.has(v))
        throw new Error(`Hash for '${s}' is already in use for '${hashToString.get(v)}`);
      hashToString.set(v, s);
      stringToHash.set(s, v);
    }
    return v;
  }
  function stringForHash(v) {
    return hashToString.get(v);
  }
  return {
    hash,
    stringForHash
  };
}



exports.useStringHashPool = useStringHashPool;
//# sourceMappingURL=chunk-XR7AMYN7.cjs.map