"use strict";

var _chunkTUWUD5A6cjs = require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/data/path.spec.ts
describe("path.spec", () => {
  it("should fix filenames", async () => {
    const samples = [
      "prn",
      "a/b/c/d.txt",
      "a\\b\\c\\d.txt",
      "trailing...",
      "...leading",
      'illegal start \\/:*?"<>| end',
      "crazy 	 white \n space \0 nil",
      "fancy \u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466} family \u21D2 \u2205 \u274C \u{1F602}.txt"
    ];
    expect(samples.map((s) => _chunkTUWUD5A6cjs.toValidFilename.call(void 0, s, " "))).toMatchInlineSnapshot(`
      Array [
        "prn ",
        "a b c d.txt",
        "a b c d.txt",
        "trailing",
        "leading",
        "illegal start end",
        "crazy white space nil",
        "fancy \u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466} family \u21D2 \u2205 \u274C \u{1F602}.txt",
      ]
    `);
  });
});
//# sourceMappingURL=path.spec.cjs.map