"use strict";

var _chunkRPAQV2V5cjs = require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/data/signal.spec.ts
describe("signal", () => {
  it("should signal", async () => {
    let copy;
    let count = 1;
    const [flag, setFlag] = _chunkRPAQV2V5cjs.useSignal.call(void 0, true, (v) => copy = v);
    const name = _chunkRPAQV2V5cjs.useSignal.call(void 0, "Henry");
    const object = _chunkRPAQV2V5cjs.useSignal.call(void 0, {
      a: 1,
      b: 2
    });
    const off = name.on((v) => ++count);
    expect(flag()).toEqual(true);
    expect(name.get()).toEqual("Henry");
    expect(copy).toEqual(void 0);
    expect(object.get()).toEqual({
      a: 1,
      b: 2
    });
    setFlag(false);
    name.set("Anna");
    object.set({
      a: 11,
      b: 22
    });
    expect(flag()).toEqual(false);
    expect(name.get()).toEqual("Anna");
    expect(copy).toEqual(false);
    expect(object.get()).toEqual({
      a: 11,
      b: 22
    });
    expect(count).toBe(2);
    name.set("Anna");
    expect(count).toBe(2);
    name.set("Cloe");
    expect(count).toBe(3);
    off();
    name.set("Diego");
    expect(count).toBe(3);
  });
});
//# sourceMappingURL=signal.spec.cjs.map