"use strict";




var _chunkAGQV4BOOcjs = require('../../chunk-AGQV4BOO.cjs');



var _chunkLHP7OTMVcjs = require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');


var _chunkW3WUDQICcjs = require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/data/sortable.spec.ts
describe("sortable", () => {
  const list = [-0.2, -1e-3, 0, 1e-3, 2];
  const items = list.map((sort_weight, index) => ({ index, sort_weight }));
  it("should add correctly", () => {
    expect(_chunkAGQV4BOOcjs.startSortWeight.call(void 0, items)).toBeLessThan(list[0]);
    expect(_chunkAGQV4BOOcjs.endSortWeight.call(void 0, items)).toBeGreaterThan(_chunkW3WUDQICcjs.last.call(void 0, list) || 0);
  });
  it("should sort correctly", () => {
    const shuffledItems = _chunkLHP7OTMVcjs.arrayShuffleForce.call(void 0, items);
    expect(shuffledItems.map((el) => el.sort_weight)).not.toEqual(list);
    expect(_chunkAGQV4BOOcjs.sortedItems.call(void 0, shuffledItems).map((el) => el.sort_weight)).toEqual(list);
  });
  it("should move correctly", () => {
    let items2 = [];
    for (let i = 0; i < 10; i++) {
      items2.push({
        name: String(i),
        sort_weight: i
      });
    }
    expect(
      _chunkAGQV4BOOcjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
    const moveItem = items2[8];
    moveItem.sort_weight = _chunkAGQV4BOOcjs.moveSortWeight.call(void 0, 1, 8, items2);
    expect(
      _chunkAGQV4BOOcjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0812345679");
    items2 = _chunkAGQV4BOOcjs.sortedItems.call(void 0, items2);
    const moveItem2 = items2[1];
    _chunkLHP7OTMVcjs.arrayShuffleInPlace.call(void 0, items2);
    moveItem2.sort_weight = _chunkAGQV4BOOcjs.moveSortWeight.call(void 0, 8, 1, items2);
    expect(
      _chunkAGQV4BOOcjs.sortedItems.call(void 0, items2).map((o) => o.name).join("")
    ).toEqual("0123456789");
  });
});
//# sourceMappingURL=sortable.spec.cjs.map