"use strict";





var _chunkY6KPVUVDcjs = require('../../chunk-Y6KPVUVD.cjs');







var _chunkJ42M6DF3cjs = require('../../chunk-J42M6DF3.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-PDXKNB3S.cjs');
require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-KMMN6P2X.cjs');
require('../../chunk-AGQV4BOO.cjs');
require('../../chunk-LURLRIHI.cjs');
require('../../chunk-67Q7IWIS.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-KCBJGJ24.cjs');
require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-SVJWXMAG.cjs');
require('../../chunk-RLHQ6YHC.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-7BEQHGH5.cjs');
require('../../chunk-VAG3XY63.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-SFVQNT7T.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-Z4FNOCPD.cjs');
require('../../chunk-GWXPD6I7.cjs');
require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-B3U4FDQH.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-RHWKNEUH.cjs');
require('../../chunk-DRU33ZUG.cjs');
require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');
require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-BXM45HLQ.cjs');
require('../../chunk-HHZVPIBD.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/log/log-filter.spec.ts
describe("log-filter", () => {
  it("should match", () => {
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "a");
      expect(matches.filter).toBe("a");
      expect(matches.accept).toEqual([/^a/]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(false);
    }
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "a*");
      expect(matches.filter).toBe("a*");
      expect(matches.accept).toEqual([/^a.*?/]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(false);
    }
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "a*,b*,-c*");
      expect(matches.filter).toBe("a*,b*,-c*");
      expect(matches.accept).toEqual([/^a.*?/, /^b.*?/]);
      expect(matches.reject).toEqual([/^c.*?/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "*,-c*");
      expect(matches.filter).toBe("*,-c*");
      expect(matches.accept).toEqual([/^.*?/]);
      expect(matches.reject).toEqual([/^c.*?/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "*,-c");
      expect(matches.filter).toBe("*,-c");
      expect(matches.accept).toEqual([/^.*?/]);
      expect(matches.reject).toEqual([/^c/]);
      expect(matches("a")).toBe(true);
      expect(matches("aa")).toBe(true);
      expect(matches("b:c")).toBe(true);
      expect(matches("c:d")).toBe(false);
    }
    {
      const matches = _chunkY6KPVUVDcjs.useNamespaceFilter.call(void 0, "*");
      expect(matches.filter).toBe("*");
      expect(matches.accept).toEqual([]);
      expect(matches.reject).toEqual([]);
      expect(matches("a")).toBe(true);
      expect(matches("b:c")).toBe(true);
    }
  });
  it("should interprete filter right", () => {
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, "")).toEqual("");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, 0)).toEqual("");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, false)).toEqual("");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, "false")).toEqual("");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, null)).toEqual("");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, "*")).toEqual("*");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, 1)).toEqual("*");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, true)).toEqual("*");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, "true")).toEqual("*");
    expect(_chunkY6KPVUVDcjs.getNamespaceFilterString.call(void 0, "a:b")).toEqual("a:b");
  });
  it("should filter by level", () => {
    {
      const levelFilter = _chunkY6KPVUVDcjs.useLevelFilter.call(void 0, "err");
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelDebug)).toBe(false);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelWarn)).toBe(false);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelError)).toBe(true);
    }
    {
      const levelFilter = _chunkY6KPVUVDcjs.useLevelFilter.call(void 0, "adfdfds");
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelDebug)).toBe(true);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelWarn)).toBe(true);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelError)).toBe(true);
    }
    {
      const levelFilter = _chunkY6KPVUVDcjs.useLevelFilter.call(void 0, _chunkJ42M6DF3cjs.LogLevelWarn);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelDebug)).toBe(false);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelWarn)).toBe(true);
      expect(levelFilter(_chunkJ42M6DF3cjs.LogLevelError)).toBe(true);
    }
  });
  it("should identify log level", () => {
    expect(_chunkY6KPVUVDcjs.parseLogLevel.call(void 0, false)).toEqual(_chunkJ42M6DF3cjs.LogLevelOff);
    expect(_chunkY6KPVUVDcjs.parseLogLevel.call(void 0, "info")).toEqual(_chunkJ42M6DF3cjs.LogLevelInfo);
    expect(_chunkY6KPVUVDcjs.parseLogLevel.call(void 0, _chunkJ42M6DF3cjs.LogLevelError)).toEqual(_chunkJ42M6DF3cjs.LogLevelError);
    expect(_chunkY6KPVUVDcjs.parseLogLevel.call(void 0, true)).toEqual(_chunkJ42M6DF3cjs.LogLevelAll);
    expect(_chunkY6KPVUVDcjs.parseLogLevel.call(void 0, 2)).toEqual(_chunkJ42M6DF3cjs.LogLevelWarn);
  });
  it("should join strings", () => {
    expect(_chunkY6KPVUVDcjs.joinLogStrings.call(void 0, "test")).toEqual(["test"]);
    expect(_chunkY6KPVUVDcjs.joinLogStrings.call(void 0, "test", "more", 1, 2, 3)).toEqual(["test more", 1, 2, 3]);
    expect(_chunkY6KPVUVDcjs.joinLogStrings.call(void 0, "test", { a: 1 })).toEqual(["test", { a: 1 }]);
    expect(_chunkY6KPVUVDcjs.joinLogStrings.call(void 0, "test", "a", "b", true, void 0, null, { a: 1 })).toEqual(["test a", "b", true, void 0, null, { a: 1 }]);
  });
});
//# sourceMappingURL=log-filter.spec.cjs.map