interface Encoder<T = any> {
    encode: (data: T) => Promise<Uint8Array>;
    decode: (data: Uint8Array) => Promise<T>;
}
declare class NoopEncoder<T> implements Encoder<T> {
    encode(data: any): Promise<Uint8Array>;
    decode(data: Uint8Array): Promise<any>;
}
declare class JsonEncoder<T> implements Encoder<T> {
    encode(data: any): Promise<Uint8Array>;
    decode(data: Uint8Array): Promise<any>;
}
declare class CryptoEncoder<T> implements Encoder<T> {
    key: CryptoKey;
    constructor(key: CryptoKey);
    encode(data: any): Promise<Uint8Array>;
    decode(data: Uint8Array): Promise<any>;
}

export { CryptoEncoder, type Encoder, JsonEncoder, NoopEncoder };
