interface TypeProps {
}
type TypeNames = 'string' | 'number' | 'boolean' | 'object' | 'any' | string;
interface Type<T = unknown> {
    type: TypeNames;
    _optional?: boolean;
    _default?: T | (() => T);
    _object?: SchemaDefinitionObject<Type<T>>;
    _union?: Type[];
    _check: (obj: any) => boolean;
    optional: () => Type<T | undefined>;
    default: (value: T | (() => T)) => Type<T | undefined>;
    parse: (obj: any, opt?: {
        transform?: boolean;
        strict?: boolean;
    }) => T;
    _props?: TypeProps;
    props: (props: TypeProps) => Type<T>;
    map: (obj: any, fn: (this: Type<T>, obj: any, schema: Type<T>) => any) => any;
}
type Infer<T> = T extends Type<infer TT> ? TT : never;
type SchemaDefinitionObject<T = any> = Record<string, Type<T>>;
type ObjectFixOptional<T> = {
    [K in keyof T as undefined extends T[K] ? K : never]?: T[K] & {};
} & {
    [K in keyof T as undefined extends T[K] ? never : K]: T[K] & {};
};
type ObjectPretty<V> = Extract<{
    [K in keyof V]: V[K];
}, unknown>;
type TypeObject<T extends SchemaDefinitionObject> = Type<ObjectPretty<ObjectFixOptional<{
    [K in keyof T]: Infer<T[K]>;
}>>>;

export type { Infer, SchemaDefinitionObject, Type, TypeNames, TypeObject, TypeProps };
