/**
 * Slightliy enhanced setTimeout to avoid garbage collection issues.
 * Returns a dispose function.
 *
 * Discussion see
 * https://jakearchibald.com/2024/garbage-collection-and-closures/
 * https://news.ycombinator.com/item?id=41111062
 */
declare function safeTimeout(fn: () => void, delay?: number, unref?: boolean): () => void;

export { safeTimeout };
