"use strict";


var _chunkKM2MJVXIcjs = require('../chunk-KM2MJVXI.cjs');
require('../chunk-IMCDDJAJ.cjs');

// src/node/env.spec.ts
describe("eNV", () => {
  it("should respect both files", () => {
    const env = {};
    _chunkKM2MJVXIcjs.setupEnv.call(void 0, {
      // debug: true,
      filename: ".editorconfig",
      prefix: "tmp_test_lib_",
      env
    });
    expect(env.tmp_test_lib_charset).toBe("utf-8");
  });
  it("should get relaxed", () => {
    const env = {
      Specific: "1",
      SPECIFIC: "2",
      PROP: "3",
      aProp: "4"
    };
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "Specific", env)).toEqual("1");
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "SPECIFIC", env)).toEqual("2");
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "specific", env)).toEqual("1");
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "prop", env)).toEqual("3");
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "APROP", env)).toEqual("4");
    expect(_chunkKM2MJVXIcjs.getEnvVariableRelaxed.call(void 0, "unknown", env)).toEqual(void 0);
  });
});
//# sourceMappingURL=env.spec.cjs.map